diff --git a/src/backend/snowball/libstemmer/stem_ISO_8859_1_portuguese.c b/src/backend/snowball/libstemmer/stem_ISO_8859_1_portuguese.c
index 06d425d008..674d9c2657 100644
--- a/src/backend/snowball/libstemmer/stem_ISO_8859_1_portuguese.c
+++ b/src/backend/snowball/libstemmer/stem_ISO_8859_1_portuguese.c
@@ -923,77 +876,77 @@ static int r_residual_form(struct SN_env * z) {
     return 1;
 }
 
-extern int portuguese_ISO_8859_1_stem(struct SN_env * z) {
+extern int portuguese_ISO_8859_1_stem(struct SN_env * z) { /* forwardmode */
     {   int c1 = z->c; /* do, line 202 */
-        {   int ret = r_prelude(z);
-            if (ret == 0) goto lab0; /* call prelude, line 202 */
+        {   int ret = r_prelude(z); /* call prelude, line 202 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
         z->c = c1;
     }
-    {   int c2 = z->c; /* do, line 203 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab1; /* call mark_regions, line 203 */
-            if (ret < 0) return ret;
-        }
-    lab1:
-        z->c = c2;
+    /* do, line 203 */
+    {   int ret = r_mark_regions(z); /* call mark_regions, line 203 */
+        if (ret == 0) goto lab1;
+        if (ret < 0) return ret;
     }
+lab1:
     z->lb = z->c; z->c = z->l; /* backwards, line 204 */
 
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 205 */
-        {   int m4 = z->l - z->c; (void)m4; /* or, line 209 */
-            {   int m5 = z->l - z->c; (void)m5; /* and, line 207 */
-                {   int m6 = z->l - z->c; (void)m6; /* or, line 206 */
-                    {   int ret = r_standard_suffix(z);
-                        if (ret == 0) goto lab6; /* call standard_suffix, line 206 */
+    {   int m2 = z->l - z->c; (void)m2; /* do, line 205 */
+        {   int m3 = z->l - z->c; (void)m3; /* or, line 209 */
+            {   int m4 = z->l - z->c; (void)m4; /* and, line 207 */
+                {   int m5 = z->l - z->c; (void)m5; /* or, line 206 */
+                    {   int ret = r_standard_suffix(z); /* call standard_suffix, line 206 */
+                        if (ret == 0) goto lab6;
                         if (ret < 0) return ret;
                     }
                     goto lab5;
                 lab6:
-                    z->c = z->l - m6;
-                    {   int ret = r_verb_suffix(z);
-                        if (ret == 0) goto lab4; /* call verb_suffix, line 206 */
+                    z->c = z->l - m5;
+                    {   int ret = r_verb_suffix(z); /* call verb_suffix, line 206 */
+                        if (ret == 0) goto lab4;
                         if (ret < 0) return ret;
                     }
                 }
             lab5:
-                z->c = z->l - m5;
-                {   int m7 = z->l - z->c; (void)m7; /* do, line 207 */
+                z->c = z->l - m4;
+                {   int m6 = z->l - z->c; (void)m6; /* do, line 207 */
                     z->ket = z->c; /* [, line 207 */
-                    if (!(eq_s_b(z, 1, s_16))) goto lab7;
+                    if (z->c <= z->lb || z->p[z->c - 1] != 'i') goto lab7; /* literal, line 207 */
+                    z->c--;
                     z->bra = z->c; /* ], line 207 */
-                    {   int m_test = z->l - z->c; /* test, line 207 */
-                        if (!(eq_s_b(z, 1, s_17))) goto lab7;
-                        z->c = z->l - m_test;
+                    {   int m_test7 = z->l - z->c; /* test, line 207 */
+                        if (z->c <= z->lb || z->p[z->c - 1] != 'c') goto lab7; /* literal, line 207 */
+                        z->c--;
+                        z->c = z->l - m_test7;
                     }
-                    {   int ret = r_RV(z);
-                        if (ret == 0) goto lab7; /* call RV, line 207 */
+                    {   int ret = r_RV(z); /* call RV, line 207 */
+                        if (ret == 0) goto lab7;
                         if (ret < 0) return ret;
                     }
                     {   int ret = slice_del(z); /* delete, line 207 */
                         if (ret < 0) return ret;
                     }
                 lab7:
-                    z->c = z->l - m7;
+                    z->c = z->l - m6;
                 }
             }
             goto lab3;
         lab4:
-            z->c = z->l - m4;
-            {   int ret = r_residual_suffix(z);
-                if (ret == 0) goto lab2; /* call residual_suffix, line 209 */
+            z->c = z->l - m3;
+            {   int ret = r_residual_suffix(z); /* call residual_suffix, line 209 */
+                if (ret == 0) goto lab2;
                 if (ret < 0) return ret;
             }
         }
     lab3:
     lab2:
-        z->c = z->l - m3;
+        z->c = z->l - m2;
     }
     {   int m8 = z->l - z->c; (void)m8; /* do, line 211 */
-        {   int ret = r_residual_form(z);
-            if (ret == 0) goto lab8; /* call residual_form, line 211 */
+        {   int ret = r_residual_form(z); /* call residual_form, line 211 */
+            if (ret == 0) goto lab8;
             if (ret < 0) return ret;
         }
     lab8:
@@ -1001,8 +954,8 @@ extern int portuguese_ISO_8859_1_stem(struct SN_env * z) {
     }
     z->c = z->lb;
     {   int c9 = z->c; /* do, line 213 */
-        {   int ret = r_postlude(z);
-            if (ret == 0) goto lab9; /* call postlude, line 213 */
+        {   int ret = r_postlude(z); /* call postlude, line 213 */
+            if (ret == 0) goto lab9;
             if (ret < 0) return ret;
         }
     lab9:
